<template>
  <doc-content-with-toc>
    <h1>Text</h1>

    <p>Note: the examples are applied on a <code>&lt;div&gt;</code> element.</p>

    <section v-for="(entries, section) in colors" :key="section">
      <h2>{{ section }}</h2>
      <table>
        <thead>
          <tr>
            <th>Without background</th>
            <th>With alternate background</th>
            <th>Inverse</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="color in entries" :key="color">
            <td class="-ps">
              <div :class="`-ps -text--color-${color}`" class="-doc-outline">-text--color-{{ color }}</div>
            </td>
            <td class="-ps">
              <div :class="`-ps -text--color-${color}-alt -bg--color-${color}`" class="-doc-outline">-text--color-{{ color }}-alt -bg--color-{{ color }}</div>
            </td>
            <td class="-ps">
              <div :class="`-ps -text--color-${color} -bg--color-${color}-alt`" class="-doc-outline">-text--color-{{ color }} -bg--color-{{ color }}-alt</div>
            </td>
          </tr>
        </tbody>
      </table>
    </section>

    <section>
      <h2>Headers look</h2>
      <p>
        If you need something that <em>looks</em> like a header, use <code>.-h1</code> to <code>.-h6</code> helpers.
      </p>
    </section>

    <section v-for="(klasses, section) in classes" :key="section">
      <h2>{{ section }}</h2>
      <div v-for="klass in klasses" :key="klass" :class="klass" class="-doc-outline -mbl">{{ klass }}</div>
    </section>
  </doc-content-with-toc>
</template>

<script>
import { colors as colorsList, states, weights } from '../../utils/constants.js'
import { DocContentWithToc } from '../../../../documentation_system/components/index.js'

const colors = {
  State: states,
  Colors: colorsList,
}

const classes = {
  Alignment: [
    '-text--center',
    '-text--left',
    '-text--right',
  ],
  Size: [
    '-text--smaller',
    '-text--small',
    '-text--default-size',
    '-text--medium',
    '-text--large',
    '-text--xlarge',
    '-text--xxlarge',
  ],
  Weight: weights.map(w => `-text--weight-${w}`),
  'Font family': [
    '-text--monospace',
  ],
  Other: [
    '-text--italic',
    '-text--ellipsis',
    '-text--struck',
    '-text--ok',
    '-text--bad',
    '-text--nowrap',
  ],
}

export default {
  name: 'TextView',
  components: { DocContentWithToc },
  data () {
    return {
      classes,
      colors,
    }
  },
  created () {
    this.$setTitle('Text')
  },
}
</script>
